de.dhbwstuttgart.typeinference

## Class TypeinferenceResultSet

- java.lang.Object
- - de.dhbwstuttgart.typeinference.TypeinferenceResultSet

    public class TypeinferenceResultSet
    extends java.lang.Object

Diese Container-Klasse kapselt alle Ergebniswerte fÃ¯Â¿Â½r eine mÃ¯Â¿Â½gliche Typkombination einer Klasse und deren Methoden sowie lokalen Variablen. Eine Instanz dieser Klasse steht fÃ¯Â¿Â½r genau eine mÃ¯Â¿Â½gliche Typkombination.
Objekte dieser Klasse werden vom Typrekonstruktionsalgorithmus Ã¯Â¿Â½ber die Compiler-API zurÃ¯Â¿Â½ckgegeben.

Version:
  $Date: 2013/09/22 20:13:02 $
Author:
  JÃ¯Â¿Â½rg BÃ¯Â¿Â½uerle

### Field Summary

Fields
`private Menge<Pair>` `constraints` Alle Constraints vor der Unifizierung.
`private Class` `ownerOfResultSet`
`private ResultSet` `unifiedConstraints` Das unifizierte ConstaraintsSet

### Constructor Summary

Constructors
Constructor and Description
`TypeinferenceResultSet(Class inferedClass, Menge<Pair> constraints, ResultSet unifiedConstraints)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `codegen()` Startet die Bytecodegenerierung dieser LÃ¶sung.
`Menge<Pair>` `getConstraints()`
`Class` `getInterferedClass()` Jedes TypeReconstructionResultSet entstand bei der Typinferierung einer Klasse.
`TypeInsertSet` `getTypeInsertionPoints()` Berechnet alle mÃ¶glichen Punkte zum Einsetzen eines Typs im Quelltext Dabei entstehen TypeInsertSets.
`Type` `getTypeOfPlaceholder(TypePlaceholder tph)` Ermittelt den in diesem ResultSet fÃ¼r den TypePlaceholder tph zugewiesenen Wert.
`ResultSet` `getUnifiedConstraints()`
`java.lang.String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### constraints

    private Menge<Pair> constraints

Alle Constraints vor der Unifizierung. Dies ist nur eine Liste von Pair-Objekten (jedes Pair Objekt bildet dabei einen Constraint: Bsp.: TA <. TB)

#### unifiedConstraints

    private ResultSet unifiedConstraints

Das unifizierte ConstaraintsSet

#### ownerOfResultSet

    private Class ownerOfResultSet

### Constructor Detail

#### TypeinferenceResultSet

    public TypeinferenceResultSet(Class inferedClass,
                                  Menge<Pair> constraints,
                                  ResultSet unifiedConstraints)

### Method Detail

#### getConstraints

    public Menge<Pair> getConstraints()

Returns:

#### getUnifiedConstraints

    public ResultSet getUnifiedConstraints()

Returns:
  Das fertige ConstraintsSet dieser CTypeRecunstructionResult

#### getTypeOfPlaceholder

    public Type getTypeOfPlaceholder(TypePlaceholder tph)

Ermittelt den in diesem ResultSet fÃ¼r den TypePlaceholder tph zugewiesenen Wert.

#### getInterferedClass

    public Class getInterferedClass()

Jedes TypeReconstructionResultSet entstand bei der Typinferierung einer Klasse.

Returns:
  Gibt die Klasse zurÃ¼ck der dieses ResultSet zugeordnet ist.

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### getTypeInsertionPoints

    public TypeInsertSet getTypeInsertionPoints()

Berechnet alle mÃ¶glichen Punkte zum Einsetzen eines Typs im Quelltext Dabei entstehen TypeInsertSets. FÃ¼r jeden gesammelten TypeInsertPoint werden alle AbhÃ¤ngigkeiten berechnet.

Returns:

#### codegen

    public void codegen()

Startet die Bytecodegenerierung dieser LÃ¶sung. Dabei wird die codegen-Methode der inferierten Klasse mit diesem ResultSet aufgerufen.